#include <avr/io.h>
#include <avr/interrupt.h>
#include <stdio.h>

#include "Fnd.h"


extern volatile unsigned char cur_temp;

volatile char disp_flag;


ISR(TIMER2_OVF_vect)
{
	char segment[11] = { 0xC0, 0xF9, 0xA4, 0xB0, 0x99, 0x92, 0x82, 0xD8, 0x80, 0x90 };
	char tmp = 0x70;
	static char pos = 0;

	TCNT2 = 256 - 125;

	DIG_OUT = 0x07;
	SEG_OUT = 0x00;

	if( disp_flag ) {
		if( pos == 0 )		SEG_OUT = segment[cur_temp / 10];
		else if( pos == 1 )	SEG_OUT = segment[cur_temp % 10];
		else if( pos == 2 )	SEG_OUT = tmp;
		DIG_OUT &= ~(1 << pos);

		pos = ++pos % 3;
	}
}

void timer2_init(void)
{
	TCCR2 = 0x04;
	TCNT2 = 256 - 125;
	TIMSK |= 0x40;
}

void fnd_init(void)
{
	SEG_DDR = 0xFF;
	DIG_DDR = 0x07;
	DIG_OUT = 0x07;

	disp_flag = 0;

	timer2_init();
}
