#include <avr/io.h>
#include <util/delay.h>

#include "key.h"


#define KEY_IN	PINE
#define KEY_DDR	DDRE


volatile char key_flag;


unsigned char getkey(unsigned char keyin)
{
	unsigned char key;

	key_flag = 0;

	key = ~KEY_IN & 0xF8;
	if( key ) {
		_delay_ms(5);
		key = ~KEY_IN & 0xF8;
		if( key ) {
			if( key == 0x08 )		key = KEY_POWER;
			else if( key == 0x10 )	key = KEY_DOOR;
			else if( key == 0x20 )	key = KEY_UP;
			else if( key == 0x40 )	key = KEY_DOWN;
			else if( key == 0x80 )	key = KEY_SET;
		}
	}

	if( key && (key != keyin) )	key_flag = 1;

	return key;
}

void key_init(void)
{
	KEY_DDR &= 0x07;
}
